// (c) 2001 Jason Pyeron
// (c) 2001 Pyerotechnics Development, Inc.
/* *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= */
/* *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= mimeparse                 = */
/* *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= */
public class mimeparse
{
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= FIELDS                    = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 java.util.Vector minimsgs=new java.util.Vector();
 public static final String specials="()<>@,;:\\\".[]";
 /* =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= */
 /* =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= msgpair                   = */
 /* =*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*= */
 class msgpair
 {
  /* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
  /* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= FIELDS                    = */
  /* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
  public java.util.Hashtable headers=new java.util.Hashtable();
  public String data="";
  public String section="";
 }
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= CONSTRUCTOR               = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public mimeparse(String src, boolean zero, boolean prefix) {minimsgs=parseit(new java.io.BufferedReader(new java.io.StringReader(src)),zero,prefix);}
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
 public mimeparse(java.io.Reader src, boolean zero, boolean prefix) {minimsgs=parseit(new java.io.BufferedReader(src),zero,prefix);}
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
 public mimeparse(java.io.BufferedReader src, boolean zero, boolean prefix) {minimsgs=parseit(src,zero,prefix);}
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= getmsgs                   = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public java.util.Vector getmsgs()
 {
  return minimsgs;
 }
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= parseit                   = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public java.util.Vector parseit(java.io.BufferedReader in, boolean zero, boolean prefix){return(parseit(in,"",zero,prefix));}
 /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
 public java.util.Vector parseit(java.io.BufferedReader in, String section, boolean zero, boolean prefix)
 {
  if (section==null) section="";
  msgpair mp=new msgpair();
  mp.section=section;
  try
  {
   String line="";
   String hdr="";
   do
   {
    line=in.readLine();
    if ((line!=null && line.length()>0 && !Character.isWhitespace(line.charAt(0))))
    {
     p(mp.headers,hdr);
     hdr="";
    }
    if (line!=null) hdr+=line;
   }
   while (line!=null && !line.equals(""));
   p(mp.headers,hdr);

   // now read the rest into a string.
   while ((line=in.readLine())!=null)
   {
    mp.data+=line+"\n";
   }

  }
  catch (java.io.IOException e)
  {
   System.err.println(e);
   e.printStackTrace();
  }

  java.util.Vector v=new java.util.Vector();

  // check for multipart
  String ct=(String)mp.headers.get("Content-Type");
  if (ct!=null && ct.indexOf("multipart")!=-1)
  {
   if (zero)
   {
    v.add(mp);
   }
   // get boundry
   int ind=ct.indexOf("boundary");
   int ind2=ct.indexOf("=",ind);
   // NOTE: this does not impliment rfc2049 to well (quoted strings)
   // START OF MESS

   //skip over whitespace
   while (Character.isWhitespace(ct.charAt(ind2))) ++ind2;
   boolean quote;
   ++ind2;
   if (quote=(ct.charAt(ind2)=='"')) ++ind2;
   int start=ind2;
   int end=start;
   if (quote)
   {
    end=ct.indexOf("\"",start);
   }
   else
   {
    while (end<ct.length() && !Character.isWhitespace(ct.charAt(end))) ++end;
   }
   // END OF MESS

   String boundry=ct.substring(start,end);

   ind=-1;
   ind2=0;
   ind=mp.data.indexOf(boundry,ind+1);
   if (ind!=-1)
   {
    java.util.Vector vs=new java.util.Vector();
    // split on boundrys
    while(ind!=-1)
    {
     vs.add(mp.data.substring(ind2,ind-2));

     ind2=ind+boundry.length()+1;

     ind=mp.data.indexOf(boundry,ind+1);
    }
    mp.data=(String)vs.remove(0);
    mp.section=(section.equals("")?"":section+".")+"0";
    // for each multipart call parseit and append to the list of mp's
    for (int x=0; x<vs.size(); ++x)
    {
     String hdrprefix="";
     if (prefix)
     {
      java.util.Hashtable hdr2=new java.util.Hashtable(mp.headers);
      hdr2.remove("Content-Type");
      hdrprefix=h(hdr2);
     }
     v.addAll(parseit(new java.io.BufferedReader(new java.io.StringReader(hdrprefix+(String)vs.get(x))),(section.equals("")?"":section+".")+(x+1),zero,prefix));
    }
   }
  }
  else
  {
   v.add(mp);
  }
  return v;
 }

 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= p                         = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public static void p(java.util.Hashtable hdrs, String src)
 {
  int ind;
  if (src==null || src.trim().length()==0 || (ind=src.indexOf(':'))==-1) return;
  hdrs.put(src.substring(0,ind),src.substring(ind+1));
 }
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= h                         = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public static String h(java.util.Hashtable headers)
 {
  java.util.Iterator i=headers.keySet().iterator();
  String res="";
  while (i.hasNext())
  {
   String key=(String)i.next();
   res+=key+":"+(String)headers.get(key)+"\n";
  }
  return res;
 }
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= strip                     = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public static String strip(String src)
 {
  if (src==null) src="";
  src=src.trim();
  for (int i=0; i<src.length(); ++i)
  {
   if (specials.indexOf(src.charAt(i))>=0) return(src.substring(0,i));
  }
  return src;
 }
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= a                         = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public static boolean a(String args[], int i, String val)
 {
  return args.length>i && args[i].equals(val);
 }
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= main                      = */
 /* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
 public static void main(String args[])
 {
  if (args.length!=4)
  {
   System.out.print("usage:\n prog inputfile( - =stdin) 0|nozero prefix|noprefix column|xml\n\n");
   System.exit(0);
  }
  //read into buffer
  mimeparse mp=null;
  try
  {
   java.io.BufferedReader in=new java.io.BufferedReader((args.length>0 && !args[0].equals("-"))?new java.io.FileReader(args[0]):new java.io.InputStreamReader(System.in));
   mp=new mimeparse(in,a(args,1,"0"),a(args,2,"prefix"));
  }
  catch (java.io.IOException e)
  {
   System.err.println(e);
   e.printStackTrace();
   System.exit(-1);
  }
  //parse
  java.util.Vector v=mp.getmsgs();

  if (a(args,3,"xml"))
  {
   System.out.println("<?xml version=\"1.0\"?>");
   for(int ii=0; ii<v.size();++ii)
   {
    msgpair mm=(msgpair)v.get(ii);
    System.out.print("<MESSAGE");
    {
     String ct=(String)mm.headers.get("Content-Type");
     if (ct!=null)
     {
      ct=strip(ct);
      if (!ct.equals("")) System.out.print(" Content-Type=\""+ct+"\"");
     }
     if (mm.section!=null && !mm.section.equals("")) System.out.print(" section=\""+mm.section+"\"");
    }
    System.out.print(">\n");
    System.out.print("<HEADERS>\n"+h(mm.headers)+"</headers>\n");
    System.out.print("<DATA>\n"+mm.data+"</data>\n");
    System.out.print("</message>\n");
   }
  }
  else
  {
   for(int ii=0; ii<v.size();++ii)
   {
    msgpair mm=(msgpair)v.get(ii);
    String ct=(String)mm.headers.get("Content-Type");
    if (ct!=null)
    {
     ct=strip(ct);
     ct+=":";
    }
    String o=h(mm.headers)+mm.data;
    java.io.BufferedReader in=new java.io.BufferedReader(new java.io.StringReader(o));
    String line;
    try
    {
     while ((line=in.readLine())!=null)
     {
      System.out.println(ct+line);
     }
    }
    catch (java.io.IOException e){}
   }

  }
 }
}


/*
 footnotes:

 #1:
  RFC #822 (Standard for ARPA Internet Text Messages) 3.2.  HEADER FIELD DEFINITIONS

       These rules show a field meta-syntax, without regard for the
  particular  type  or internal syntax.  Their purpose is to permit
  detection of fields; also, they present to  higher-level  parsers
  an image of each field as fitting on one line.

  field       =  field-name ":" [ field-body ] CRLF

  field-name  =  1*<any CHAR, excluding CTLs, SPACE, and ":">

  field-body  =  field-body-contents
                 [CRLF LWSP-char field-body]

  field-body-contents =
                <the ASCII characters making up the field-body, as
                 defined in the following sections, and consisting
                 of combinations of atom, quoted-string, and
                 specials tokens, or else consisting of texts>


*/
